lens-5.3.3: Lenses, Folds and Traversals

Copyright | (C) 2012-2016 Edward Kmett
License | BSD-style (see the file LICENSE)
Maintainer | Edward Kmett <ekmett@gmail.com>
Stability | experimental
Portability | non-portable
Safe Haskell | Safe-Inferred
Language | Haskell2010

Control.Lens.Internal.Prism

Description

Synopsis

- data Market a b s t = Market (b -> t) (s -> Either t a)
- type Market' a = Market a a

# Documentation

data Market a b s t #

This type is used internally by the `Prism` code to provide efficient access to the two parts of a `Prism`.

Constructors

Market (b -> t) (s -> Either t a) |

#### Instances

Instances details

Choice (Market a b) # |
Instance details Defined in Control.Lens.Internal.Prism Methods left' :: Market a b a0 b0 -> Market a b (Either a0 c) (Either b0 c) # right' :: Market a b a0 b0 -> Market a b (Either c a0) (Either c b0) #
Profunctor (Market a b) # |

Instance details

Defined in Control.Lens.Internal.Prism

Methods

dimap :: (a0 -> b0) -> (c -> d) -> Market a b b0 c -> Market a b a0 d #

lmap :: (a0 -> b0) -> Market a b b0 c -> Market a b a0 c #

rmap :: (b0 -> c) -> Market a b a0 b0 -> Market a b a0 c #

(#.) :: forall a0 b0 c q. Coercible c b0 => q b0 c -> Market a b a0 b0 -> Market a b a0 c #

(.#) :: forall a0 b0 c q. Coercible b0 a0 => Market a b b0 c -> q a0 b0 -> Market a b a0 c #

Functor (Market a b s) # |
Instance details Defined in Control.Lens.Internal.Prism Methods fmap :: (a0 -> b0) -> Market a b s a0 -> Market a b s b0 # (<$) :: a0 -> Market a b s b0 -> Market a b s a0 #

type Market' a = Market a a #

    type Market' a s t = Market a a s t